/**
 * Argo Workflows API
 * Argo Workflows is an open source container-native workflow engine for orchestrating parallel jobs on Kubernetes. For more information, please see https://argoproj.github.io/argo-workflows/
 *
 * OpenAPI spec version: VERSION
 * 
 *
 * NOTE: This class is auto generated by OpenAPI Generator (https://openapi-generator.tech).
 * https://openapi-generator.tech
 * Do not edit the class manually.
 */

import { IoK8sApiCoreV1ConfigMapKeySelector } from '../models/IoK8sApiCoreV1ConfigMapKeySelector';
import { HttpFile } from '../http/http';

/**
* ValueFrom describes a location in which to obtain the value to a parameter
*/
export class IoArgoprojWorkflowV1alpha1ValueFrom {
    'configMapKeyRef'?: IoK8sApiCoreV1ConfigMapKeySelector;
    /**
    * Default specifies a value to be used if retrieving the value from the specified source fails
    */
    '_default'?: string;
    /**
    * Selector (https://github.com/antonmedv/expr) that is evaluated against the event to get the value of the parameter. E.g. `payload.message`
    */
    'event'?: string;
    /**
    * Expression, if defined, is evaluated to specify the value for the parameter
    */
    'expression'?: string;
    /**
    * JQFilter expression against the resource object in resource templates
    */
    'jqFilter'?: string;
    /**
    * JSONPath of a resource to retrieve an output parameter value from in resource templates
    */
    'jsonPath'?: string;
    /**
    * Parameter reference to a step or dag task in which to retrieve an output parameter value from (e.g. \'{{steps.mystep.outputs.myparam}}\')
    */
    'parameter'?: string;
    /**
    * Path in the container to retrieve an output parameter value from in container templates
    */
    'path'?: string;
    /**
    * SuppliedValueFrom is a placeholder for a value to be filled in directly, either through the CLI, API, etc.
    */
    'supplied'?: any;

    static readonly discriminator: string | undefined = undefined;

    static readonly attributeTypeMap: Array<{name: string, baseName: string, type: string, format: string}> = [
        {
            "name": "configMapKeyRef",
            "baseName": "configMapKeyRef",
            "type": "IoK8sApiCoreV1ConfigMapKeySelector",
            "format": ""
        },
        {
            "name": "_default",
            "baseName": "default",
            "type": "string",
            "format": ""
        },
        {
            "name": "event",
            "baseName": "event",
            "type": "string",
            "format": ""
        },
        {
            "name": "expression",
            "baseName": "expression",
            "type": "string",
            "format": ""
        },
        {
            "name": "jqFilter",
            "baseName": "jqFilter",
            "type": "string",
            "format": ""
        },
        {
            "name": "jsonPath",
            "baseName": "jsonPath",
            "type": "string",
            "format": ""
        },
        {
            "name": "parameter",
            "baseName": "parameter",
            "type": "string",
            "format": ""
        },
        {
            "name": "path",
            "baseName": "path",
            "type": "string",
            "format": ""
        },
        {
            "name": "supplied",
            "baseName": "supplied",
            "type": "any",
            "format": ""
        }    ];

    static getAttributeTypeMap() {
        return IoArgoprojWorkflowV1alpha1ValueFrom.attributeTypeMap;
    }

    public constructor() {
    }
}

