/**
 * Argo Workflows API
 * Argo Workflows is an open source container-native workflow engine for orchestrating parallel jobs on Kubernetes. For more information, please see https://argoproj.github.io/argo-workflows/
 *
 * OpenAPI spec version: VERSION
 * 
 *
 * NOTE: This class is auto generated by OpenAPI Generator (https://openapi-generator.tech).
 * https://openapi-generator.tech
 * Do not edit the class manually.
 */

import { IoArgoprojWorkflowV1alpha1WorkflowSpec } from '../models/IoArgoprojWorkflowV1alpha1WorkflowSpec';
import { IoK8sApimachineryPkgApisMetaV1ObjectMeta } from '../models/IoK8sApimachineryPkgApisMetaV1ObjectMeta';
import { HttpFile } from '../http/http';

/**
* CronWorkflowSpec is the specification of a CronWorkflow
*/
export class IoArgoprojWorkflowV1alpha1CronWorkflowSpec {
    /**
    * ConcurrencyPolicy is the K8s-style concurrency policy that will be used
    */
    'concurrencyPolicy'?: string;
    /**
    * FailedJobsHistoryLimit is the number of failed jobs to be kept at a time
    */
    'failedJobsHistoryLimit'?: number;
    /**
    * Schedule is a schedule to run the Workflow in Cron format
    */
    'schedule': string;
    /**
    * StartingDeadlineSeconds is the K8s-style deadline that will limit the time a CronWorkflow will be run after its original scheduled time if it is missed.
    */
    'startingDeadlineSeconds'?: number;
    /**
    * SuccessfulJobsHistoryLimit is the number of successful jobs to be kept at a time
    */
    'successfulJobsHistoryLimit'?: number;
    /**
    * Suspend is a flag that will stop new CronWorkflows from running if set to true
    */
    'suspend'?: boolean;
    /**
    * Timezone is the timezone against which the cron schedule will be calculated, e.g. \"Asia/Tokyo\". Default is machine\'s local time.
    */
    'timezone'?: string;
    'workflowMetadata'?: IoK8sApimachineryPkgApisMetaV1ObjectMeta;
    'workflowSpec': IoArgoprojWorkflowV1alpha1WorkflowSpec;

    static readonly discriminator: string | undefined = undefined;

    static readonly attributeTypeMap: Array<{name: string, baseName: string, type: string, format: string}> = [
        {
            "name": "concurrencyPolicy",
            "baseName": "concurrencyPolicy",
            "type": "string",
            "format": ""
        },
        {
            "name": "failedJobsHistoryLimit",
            "baseName": "failedJobsHistoryLimit",
            "type": "number",
            "format": ""
        },
        {
            "name": "schedule",
            "baseName": "schedule",
            "type": "string",
            "format": ""
        },
        {
            "name": "startingDeadlineSeconds",
            "baseName": "startingDeadlineSeconds",
            "type": "number",
            "format": ""
        },
        {
            "name": "successfulJobsHistoryLimit",
            "baseName": "successfulJobsHistoryLimit",
            "type": "number",
            "format": ""
        },
        {
            "name": "suspend",
            "baseName": "suspend",
            "type": "boolean",
            "format": ""
        },
        {
            "name": "timezone",
            "baseName": "timezone",
            "type": "string",
            "format": ""
        },
        {
            "name": "workflowMetadata",
            "baseName": "workflowMetadata",
            "type": "IoK8sApimachineryPkgApisMetaV1ObjectMeta",
            "format": ""
        },
        {
            "name": "workflowSpec",
            "baseName": "workflowSpec",
            "type": "IoArgoprojWorkflowV1alpha1WorkflowSpec",
            "format": ""
        }    ];

    static getAttributeTypeMap() {
        return IoArgoprojWorkflowV1alpha1CronWorkflowSpec.attributeTypeMap;
    }

    public constructor() {
    }
}

